#include <iostream.h>
#include <limits.h>
#include <stdlib.h>
#include <conio.h>
#include <stdio.h>
#include "prvky.h"

int k_max(polozky *p, int k) {
  int max, min, citac;

  max = INT_MAX;
  min = -1;

  for (int i = 0; i < p->pocet(); i ++) {
    if ((p->klic(i) > min) && (p->klic(i) < max)) {
      citac = 1;
      for (int j = 0; j < p->pocet(); j ++) {
	if (p->klic(i) < p->klic(j)) citac ++;
	if (citac > k) break;
      }
      if (citac == k) return i;
      if (citac < k) max = p->klic(i);
      if (citac > k) min = p->klic(i);
    }
  }

  return -1;
}

int hoar(polozky *p, int k) {
  int min, max;
  int i, j, klic;
  thodnota h;
  if ( (k > 0)&&(k <= p->pocet()) ) k--;
  else {
    return -1;
  }

  min = 0;
  max = p->pocet()-1;
  while (min < max) {
    klic = p->klic(k);
    i = min;
    j = max;
    while (i < j) {
      while ((p->klic(i)) > klic) i ++;
      while ((p->klic(j)) < klic) j --;
      if (i <= j) {
	h = p->getHodnota(i);
	p->setHodnota(i, p->getHodnota(j));
	p->setHodnota(j, h);
	i++;
	j--;
      }
    }
    if (j < k) min = i;
    if (i > k) max = j;
  }
  return k;
}

int main() {
  polozky p(POC);
  int m, prv = 9;

  clrscr();
  if (!cti(SOUBOR, &p)) return 0;

  pis(&p);
  cout << " pocet prvku: " << p.pocet() << "\n";

  while ( (prv = pocetp()) != -1) {
    cout << " hledam " << prv << " nejvetsi prvek: ";
    m = hoar(&p, prv);

    if (m != -1) cout << p.klic(m)  << "\n";
    else cout << "takovy prvek neexistuje\n";
    pis(&p);
  }

  return 1;
}