#define POC 10
#define SOUBOR "cisla.txt"

typedef int thodnota;

class polozka {
  thodnota hodnota;

 public:
  void setHodnota(thodnota h) {
    hodnota = h;
  }

  thodnota getHodnota() {
    return hodnota;
  }

  int klic() {
    return hodnota;
  }
};

class polozky {
  polozka *a;
  int pocetv;

 public:
  polozky(int p) {
    a = new polozka[p];
    pocetv = p;
  }

  ~polozky() {
    delete[] a;
  }

  int zkus_klic(int ii, int k)  {
    for (int i = 0; i < ii; i ++) {
      if (a[i].klic() == k) return 0;
    }
    return 1;
  }

  int setHodnota(int i, thodnota h) {
    if ((i >= 0)&&(i < pocet())) {
      a[i].setHodnota(h);
      polozka pomoc;
      pomoc.setHodnota(h);
      if (!zkus_klic(i, pomoc.klic())) return 0;
      return 1;
    } else return 0;
  }

  thodnota getHodnota(int i) {
    if ((i >= 0)&&(i < pocet())) {
      return a[i].getHodnota();
    }
    cout << "Cteni mimo pole\n";
    return 0;
  }

  int klic(int i) {
    if ((i >= 0)&&(i < pocet())) {
      return a[i].klic();
    }
    cout << "Cteni mimo pole\n";
    return 0;
  }

  int pocet() {
    return pocetv;
  }
};

int cti(char *soubor, polozky *p) {
  FILE *f;
  thodnota h;
  int i = 0;

  f = fopen(soubor, "rt");
  if (f == NULL) {
    cout << "Nepodarilo se otevrit soubor: " << soubor << "\n";
    return 0;
  }
  while (fscanf(f, "%d", &h) != EOF) {
    if (!(p->setHodnota(i, h))) {
      cout << "Jiz existujici hodnota klice u prvku s hodnotou: " << h << "\n";
      return 0;
    }
    if (!(i < POC)) {
      cout << "V souboru je vice prvku nez je rozsah pole\n";
      return 0;
    }
    i ++;
  }

  if ((i != POC)) {
    cout << "V souboru je mene prvku nez je rozsah pole\n";
    return 0;
  }

/*
  for (i = 0; i < p->pocet(); i ++) {
    while (!(p->setHodnota(i, random(POC))));
  }
*/
  fclose(f);
  return 1;
}

void pis(polozky *p) {
  for (int i = 0; i < p->pocet()-1; i ++) {
    cout << p->klic(i) << ",";
  }
  cout << p->klic(i) << "\n";
}

int pocetp() {
  int prv;
  cout << "\n Zadej k-ty nejvetsi prvek (-1 pro ukonceni):";
  scanf("%d", &prv);
  return prv;
}

